<script lang="ts" context="module">
	import type { Value } from "./Value";
	import type { RegConf } from "./RegisterConf.svelte";
	import type { Error } from "./Error.svelte";
	import type { TimeT } from "./Time.svelte";

	export type Read = { addr: number; value: Value };
	export type Poll = Record<number, Value>;
	export type History = [TimeT, { Error?: Error; Read?: Read; Poll: Poll }];

	export type Configuration = {
		poll_interval?: { secs: number; nanos: number };
		slots: Record<number, RegConf>;
	};

	export type Message = {
		Configuration?: Configuration;
		History?: History;
		HistoryLagged: number;
	};

	const HIST_SIZE = 50;
</script>

<script lang="ts">
	import Errors from "./Errors.svelte";
	import Register from "./Register.svelte";
	import { GetVal } from "./utils";

	let conf: Configuration | undefined;
	let register: Record<number, [TimeT, Value]> = {};
	let errors: Array<[TimeT, Error]> = [];

	let connected = false;

	let ws: WebSocket;
	function reconnect() {
		conf = undefined;
		register = {};
		errors = [];

		console.log("Connecting");
		ws = new WebSocket("ws://localhost:8888");
		ws.onmessage = (e) => {
			connected = true;
			const m: Message = JSON.parse(e.data);

			if (m.History) {
				const time = m.History[0];
				const hist = m.History[1];

				if (hist.Error) {
					const error = hist.Error;
					errors = [[time, error], ...errors.slice(0, HIST_SIZE - 1)];
				} else if (hist.Read) {
					const read = hist.Read;
					register[read.addr] = [time, read.value];
				} else if (hist.Poll) {
					const poll = hist.Poll;
					for (const k in poll) {
						register[k] = [time, poll[k]];
					}
				} else {
					console.warn(m);
				}
			} else if (m.Configuration) {
				conf = m.Configuration;
			} else {
				console.warn(m);
			}
		};

		ws.onclose = () => (connected = false);
	}
	reconnect();

	$: ids = Object.keys(conf?.slots ?? []).map((e) => parseInt(e));

	let addRegId: number | null = null;

	function addReg() {
		ws.send(
			JSON.stringify({
				SetRegisterConf: { reg_id: addRegId, conf: { Zero: null } },
			})
		);
		addRegId = null;
	}

	function del(id: number) {
		ws.send(
			JSON.stringify({
				SetRegisterConf: { reg_id: +id, conf: null },
			})
		);
		addRegId = null;
	}

	function update(id: number, conf: RegConf) {
		ws.send(
			JSON.stringify({
				SetRegisterConf: { reg_id: +id, conf },
			})
		);
	}

	function setPoll(secs: number) {
		ws.send(
			JSON.stringify({
				SetPoll: { secs, nanos: 0 },
			})
		);
	}
</script>

<main>
	<h1>Mod Bus Emu</h1>

	{#if !connected}
		<div id="reconnect">
			<button on:click={reconnect}>Reconnect</button>
		</div>
	{:else}
		<div id="firstRow">
			<form on:submit|preventDefault={addReg}>
				<input
					id="addReg"
					type="number"
					bind:value={addRegId}
					placeholder="Register ID"
				/>
				<button type="submit">Add register</button>
			</form>
			<span class="spacer" />
			<label>
				Refresh every
				<input
					type="number"
					step="1"
					id="everySec"
					min="0"
					on:input={(e) => setPoll(+GetVal(e))}
					value={conf.poll_interval?.secs}
				/>
				seconds
			</label>
		</div>
		<hr />
		{#each ids as id (id)}
			<Register
				{id}
				last={register[id]}
				conf={conf.slots[id]}
				on:value={(e) => update(id, e.detail)}
				on:delete={() => del(id)}
			/>
			<hr />
		{/each}

		<Errors {errors} />
	{/if}
</main>

<style lang="sass">
	main
		padding: 1em
		padding-bottom: 60px
		margin: 0 auto
	
	#reconnect
		font-size: 1.3em
		text-align: center

	#firstRow
		display: flex
		.spacer
			flex: 1
		#addReg
			text-align: center
			width: 125px
		#everySec
			width: 65px
			border: none
			text-align: center

	h1
		text-align: center
		color: #ff3e00
		text-transform: uppercase
		font-size: 4em
		font-weight: 100
</style>
